//------------------------------------------------------------------
#property copyright "http://www.forex-tsd.com/"
#property link      "http://www.forex-tsd.com/"
//------------------------------------------------------------------
#include <stdlib.mqh>

extern int    MagicNumber   = 246810;
extern double Lots          = 0.1;
extern int    TrixTimeFrame = 0;
extern int    TrixBarToTest = 1;       
extern int    TrixPeriod    = 14;
extern int    TrixPrice     = PRICE_CLOSE;
extern int    SignalPeriod  = 9;
extern int    SignalMode    = MODE_LWMA;
extern bool   showMessages  = true;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()   { return(0); }
int deinit()
{
   switch(UninitializeReason())
   {
      case REASON_CHARTCHANGE:
      case REASON_PARAMETERS:  break;
      case REASON_RECOMPILE:
      case REASON_CHARTCLOSE:
      case REASON_REMOVE:
      case REASON_ACCOUNT:     if (showMessages) for(int i=0; i<10; i++)  ObjectDelete("msg.que"+i);
   }
   return(0);
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _doNothing  0      
#define _doOpenBuy  1      
#define _doOpenSell 2      
int start()
{
   if (!CheckTerminalStatus()) return(0); showTwoStateMessage("working","Trix Candles EA working",true);

   //
   //
   //
   //
   //

   int trendCurr = iCustom(NULL,TrixTimeFrame,"Trix log Candles",TrixPeriod,TrixPrice,SignalPeriod,SignalMode,7,TrixBarToTest);
   int trendPrev = iCustom(NULL,TrixTimeFrame,"Trix log Candles",TrixPeriod,TrixPrice,SignalPeriod,SignalMode,7,TrixBarToTest+1);
      int doWhat = _doNothing;
         if (trendCurr!=trendPrev)
            if (trendCurr>0)
                  doWhat = _doOpenBuy;
            else  doWhat = _doOpenSell;
      if (doWhat == _doNothing) return(0);

   //
   //
   //
   //
   //
   
      for (int i=OrdersTotal()-1; i>=0; i--)
      { 
         OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
            if (OrderSymbol()!=Symbol())           continue;
            if (OrderMagicNumber() != MagicNumber) continue;
            
            //
            //
            //
            //
            //
            
            if (OrderType()==OP_BUY && doWhat == _doOpenSell) 
            {
               RefreshRates();
               for(int c=0 ; c<3; c++)
               {
                  OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),0,CLR_NONE);
                     int err=GetLastError();
                     checkError(OrderSymbol()+" buy order closed",err);
                     if(err==4 || err==136 || err==137 || err==138 || err==146)
                     {
                        RefreshRates();
                        continue;
                     }
                     break; 
               }            
            }                        
            
            //
            //
            //
            //
            //
            
            if (OrderType()==OP_SELL && doWhat == _doOpenBuy) 
            {
               RefreshRates();
               for(c=0 ; c<3; c++)
               {
                  OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),0,CLR_NONE);
                     err=GetLastError();
                     checkError(OrderSymbol()+" sell order closed",err);
                     if(err==4 || err==136 || err==137 || err==138 || err==146)
                     {
                        RefreshRates();
                        continue;
                     }
                     break; 
               }                     
            }               
      }   
   
   //
   //
   //
   //
   //

      int openedOrders = 0;
      for (i=OrdersTotal()-1; i>=0; i--)
      { 
         OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
            if (OrderSymbol()!=Symbol())           continue;
            if (OrderMagicNumber() != MagicNumber) continue;
               openedOrders++;
      }
      if (openedOrders == 0)
      {
      
         //
         //
         //
         //
         //
         
         if (doWhat == _doOpenBuy)
         {
               RefreshRates();
               for(c=0 ; c<3; c++)
               {
                  OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,Digits),0,0,0,"Trix Candles EA buy order",MagicNumber,0,CLR_NONE);
                     err=GetLastError();
                     checkError(OrderSymbol()+" buy order opened",err);
                     if(err==4 || err==136 || err==137 || err==138 || err==146)
                     {
                        RefreshRates();
                        continue;
                     }
                     break; 
               }                     
         }
         
         //
         //
         //
         //
         //
         
         if (doWhat == _doOpenSell)
         {
               RefreshRates();
               for(c=0 ; c<3; c++)
               {
                  OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,Digits),0,0,0,"Trix Candles EA sell order",MagicNumber,0,CLR_NONE);
                     err=GetLastError();
                     checkError(OrderSymbol()+" sell order opened",err);
                     if(err==4 || err==136 || err==137 || err==138 || err==146)
                     {
                        RefreshRates();
                        continue;
                     }
                     break; 
               }                     
         }
   }
   return(0);      
}

//----------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------
//
//
//
//
//

bool CheckTerminalStatus()
{
   bool status=false;
   
   //
   //
   //
   //
   //
   
   while(true)
   {
         if (!IsConnected())
             { showTwoStateMessage("connected","No connection to server",False); break; }
         else  showTwoStateMessage("connected","Conected to server",true);
         if ( IsStopped())
             { showTwoStateMessage("stopped","EA stopped",False); break; }  
         else  showTwoStateMessage("stopped","EA started",true);
         if (!IsTradeAllowed())
             { showTwoStateMessage("allowed","Trading not allowed",false); break; }
         else  showTwoStateMessage("allowed","Trading allowed",true);
         if (!IsExpertEnabled() && !IsTesting())
            { showTwoStateMessage("disabled","EA''s are disabled",false); break; }
         else showTwoStateMessage("disabled","EA''s are enabled",true);
         if ( IsTradeContextBusy())
            { showTwoStateMessage("busy","Trade contest busy",false); break; }
         else showTwoStateMessage("busy","Trade contest ready",true);
         
      //
      //
      //
      //
      //
      
      status=true;
      break;
   }
   return(status);
}

//----------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

bool   msg.errState[];
string msg.errNames[];
string msg.messageText[10];
color  msg.messageColor[10];
int    msg.lastMessage=0;

//
//
//
//
//

void checkError(string what,int err)
{
   showMessage(what);
   if(err!=0)
         showMessage("error occured :"+ErrorDescription(err),Red);

}

//
//
//
//
//

void showTwoStateMessage(string name, string message, bool state)
{
   for(int i=ArraySize(msg.errNames)-1; i>-1; i--) if (msg.errNames[i]==name) break;
   if (i==-1)
      {
         int size = ArraySize(msg.errNames)+1;
         i = size-1;
            ArrayResize(msg.errNames,size); msg.errNames[i] = name;
            ArrayResize(msg.errState,size); msg.errState[i] = -1;
      }

   //
   //
   //
   //
   //

   if (msg.errState[i]!= state)
   {   
      msg.errState[i] = state;
      if (state==false)
            showMessage(message,Red);
      else  showMessage(message,Green);
   }      
}

//
//
//
//
//

void showMessage(string text, color theColor=Gray)
{
   if(!showMessages) { Print(text); return; }
   if(msg.lastMessage>9)
   {
      for(int i=0; i<9; i++)
      {
         msg.messageText[i] =msg.messageText[i+1];
         msg.messageColor[i]=msg.messageColor[i+1];
      }
      msg.lastMessage = 9;
   }

   //
   //
   //    set message que text and color
   //
   //
   
      msg.messageText[msg.lastMessage]  = text+" - "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
      msg.messageColor[msg.lastMessage] = theColor;
   
   //
   //
   //
   //
   //
      
   for(i=0; i<=msg.lastMessage; i++)
   {
      string name = "msg.que"+i;
      if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_LABEL,0,0,0);
            ObjectSet(name,OBJPROP_CORNER  ,3);
            ObjectSet(name,OBJPROP_XDISTANCE,5);
            ObjectSet(name,OBJPROP_YDISTANCE,5+14*i);
      }
      ObjectSetText(name,msg.messageText[i],9,"Arial",msg.messageColor[i]);
   }
   msg.lastMessage++;
   WindowRedraw();
}